using Distributed
@everywhere begin
  using Nemo, Hecke
  using ProgressMeter
end

task = @distributed for l in collect(PrimesSet(17,10^4))
  l = ZZ(l)
  # Flags for whether congruences for (1-24b/l) = 0,-1 and (24b-1/Q) = +1,-1
  # have been ruled out.
  flag0 = false
  flagn = false
  Rl = ResidueRing(ZZ,Int(l))
  for Q in PrimesSet(ZZ(13),ZZ(-1),l,l-1)
    # The prefactor in the middle term of the Hecke operator for delta = 0.
    prefactor0 = Q^divexact((l-1)^2-4,2) * jacobi_symbol(-1,Q)*jacobi_symbol(12,Q)
    # The prefactor in the middle term of the Hecke operator for delta = -1.
    prefactorn = Q^divexact(l^2-5,2) * jacobi_symbol(-1,Q)*jacobi_symbol(12,Q)
    # Flags for whether n with (-n/l) = 0,-1 and (n/Q) = +1,-1 has been found.
    n0p = false
    n0n = false
    nnp = false
    nnn = false
    for n in Iterators.countfrom(23,24)
      n = ZZ(n)
      jsQ = jacobi_symbol(n,Q)
      jsQ == 0 && continue
      jsl = jacobi_symbol(-n,l)
      if !flag0 && !n0p && jsl == 0 && jsQ == 1
        n0p = true
        if !iszero(Rl(number_of_partitions(divexact(n*Q^2+1,24))) +
                   prefactor0 * jsQ * Rl(number_of_partitions(divexact(n+1,24))))
          flag0 = true
        end
      elseif !flag0 && !n0n && jsl == 0 && jsQ == -1
        n0n = true
        if !iszero(Rl(number_of_partitions(divexact(n*Q^2+1,24))) +
                   prefactor0 * jsQ * Rl(number_of_partitions(divexact(n+1,24))))
          flag0 = true
        end
      elseif !flagn && !nnp && jsl == -1 && jsQ == 1
        nnp = true
        if !iszero(Rl(number_of_partitions(divexact(n*Q^2+1,24))) +
                   prefactorn * jsQ * Rl(number_of_partitions(divexact(n+1,24))))
          flagn = true
        end
      elseif !flagn && !nnn && jsl == -1 && jsQ == -1
        nnn = true
        if !iszero(Rl(number_of_partitions(divexact(n*Q^2+1,24))) +
                   prefactorn * jsQ * Rl(number_of_partitions(divexact(n+1,24))))
          flagn = true
        end
      end
      if (flag0||(n0p&&n0n)) && (flagn||(nnp&&nnn))
        break
      end
    end
    if flag0 && flagn
      break
    end
  end
end
